using BAP.MQTTnet.Test.Models;
using BPA.MQTTnet.Samples.Client;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using MQTTnet;
using MQTTnet.Client;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

namespace BAP.MQTTnet.Test.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
           // Client_Connection_Samples.Connect_Client();
            //  Task.WaitAll(Publish_Application_Message());
            Handle_Received_Application_Message();
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }

        public static async Task Publish_Application_Message()
        {
            /*
             * This sample pushes a simple application message including a topic and a payload.
             *
             * Always use builders where they exist. Builders (in this project) are designed to be
             * backward compatible. Creating an _MqttApplicationMessage_ via its constructor is also
             * supported but the class might change often in future releases where the builder does not
             * or at least provides backward compatibility where possible.
             */

            var mqttFactory = new MqttFactory();

            using (var mqttClient = mqttFactory.CreateMqttClient())
            {
                var mqttClientOptions = new MqttClientOptionsBuilder()
                    .WithTcpServer("10.2.1.21", 1883)
                    .Build();

                await mqttClient.ConnectAsync(mqttClientOptions, CancellationToken.None);

                var applicationMessage = new MqttApplicationMessageBuilder()
                    .WithTopic("mqttnet/samples/topic/2")
                    .WithPayload("19.asssssssssss5")
                    .Build();

                await mqttClient.PublishAsync(applicationMessage, CancellationToken.None);

                Console.WriteLine("MQTT application message is published.");
            }
        }

        public  async Task Handle_Received_Application_Message()
        {
            /*
             * This sample subscribes to a topic and processes the received message.
             */

            var mqttFactory = new MqttFactory();

            using (var mqttClient = mqttFactory.CreateMqttClient())
            {
                var mqttClientOptions = new MqttClientOptionsBuilder()
                    .WithTcpServer("10.2.1.21", 1883)
                    .WithCredentials("client1","222")
                    .WithTimeout(TimeSpan.FromMilliseconds(200))
                    .WithClientId(Guid.NewGuid().ToString().Substring(0,5))
                    .Build();

                // Setup message handling before connecting so that queued messages
                // are also handled properly. When there is no event handler attached all
                // received messages get lost.
           

               var p=  await mqttClient.ConnectAsync(mqttClientOptions);

                //mqttClient.UseConnectedHandler(async e =>
                //{
                //    Console.WriteLine("### CONNECTED WITH SERVER ###");

                //    // Subscribe to a topic
                //    await mqttClient.SubscribeAsync(new MqttTopicFilterBuilder().WithTopic("my/topic").Build());

                //    Console.WriteLine("### SUBSCRIBED ###");
                //});

                var mqttSubscribeOptions = mqttFactory.CreateSubscribeOptionsBuilder()
               .WithTopicFilter(f => { f.WithTopic("mqttnet/samples/topic/2"); })
               .Build();

                mqttClient.ApplicationMessageReceivedAsync += e =>
                {
                    var a = e.ApplicationMessage.Topic;
                    Console.WriteLine("Received application message.");
                    // e.DumpToConsole();

                    return Task.CompletedTask;
                };
                 mqttClient.DisconnectedAsync+=async e =>  
                {
                    Console.WriteLine("与服务器之间的连接断开了，正在尝试重新连接");
                    await Task.Delay(TimeSpan.FromSeconds(5));
                    try
                    {
                        // 重新连接
                        await mqttClient.ConnectAsync(mqttClientOptions);
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine($"重新连接服务器失败:{ex}");
                    }

                    //return Task.CompletedTask;
                };
                await mqttClient.SubscribeAsync(mqttSubscribeOptions, CancellationToken.None);
                //using (var timeoutToken = new CancellationTokenSource(TimeSpan.FromSeconds(1)))
                //{
                  
                //}

               // var data =  await mqttClient.SubscribeAsync(mqttSubscribeOptions);

                //Console.WriteLine("MQTT client subscribed to topic.");

                //Console.WriteLine("Press enter to exit.");
                Console.ReadLine();
            }
        }
    }
}
